#include "snes9x.h"
#include "memmap.h"
#include "ppu.h"
#include "dsp1.h"
#include "cpuexec.h"
#include "debug.h"
#include "apu.h"
#include "dma.h"

void S9xResetSA1 ()
{
    SA1.PB = 0;
    SA1.PC = S9xGetWord (0xFFFC);
    SA1.D.W = 0;
    SA1.DB = 0;
    SA1.SH = 1;
    SA1.SL = 0xFF;
    SA1.XH = 0;
    SA1.YH = 0;
    SA1.P.W = 0;

    SA1.ShiftedPB = 0;
    SA1.ShiftedDB = 0;
    SA1SetFlags (MemoryFlag | IndexFlag | IRQ | Emulation);
    SA1ClearFlags (Decimal);

    SA1.Flags = 0;
    SA1.Cycles = 0;
    SA1.NextEvent = Settings.HBlankStart;
    SA1.V_Counter = 0;
    SA1.BranchSkip = FALSE;
    SA1.NMIActive = FALSE;
    SA1.IRQActive = FALSE;
    SA1.WaitingForInterrupt = FALSE;
    SA1.InDMA = FALSE;
    SA1.WhichEvent = HBLANK_START_EVENT;
    SA1.PC = NULL;
    SA1.PCBase = NULL;
    SA1.MemSpeed = 8;
    SA1.MemSpeedx2 = 16;
    SA1.FastROMSpeed = 8;
    SA1.PCAtOpcodeStart = NULL;
    SA1.WaitAddress = NULL;
    SA1.WaitCounter = 0;
    S9xSA1SetPCBase (Registers.PC);

    SA1.Speed = S9xE1M1X1;
    SA1.S9xOpcodes = S9xOpcodesM1X1;
    SA1.CPUExecuting = TRUE;

    S9xSA1UnpackStatus();
}
