/*****************************************************************************/
/*  Snes9X: Win32                                                            */
/*****************************************************************************/
#if !defined(SNES9X_H_INCLUDED)
#define SNES9X_H_INCLUDED
/*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include <windowsx.h>
#include <afxres.h>
#include <ddraw.h>
#include <dsound.h>
#include "resource.h"

/*****************************************************************************/

struct sGUI {
	HWND hWnd;
	HMENU hMenu;
	HINSTANCE hInstance;

	DWORD hFrameTimer;
	HANDLE hDrawFrame;
	DWORD FrameTimerStart;

	BYTE Language;

	char SoundMode;
	bool Stereo;

	bool ForcedPauseEmulation;
	bool PauseEmulation;
	bool StopEmulation;

	int Width;
	int Height;
	int Depth;
	int Scale;
	bool DoubleBuffered;
};

struct sLanguages {
	int idMenu;
	char *errInitDD;
	char *errModeDD;
	char *errInitDS;
	char *ApplyNeedRestart;
	char *errFrameTimer;
};

struct SJoypad {
	BOOL Enabled;
    WORD Left;
    WORD Right;
    WORD Up;
    WORD Down;
    WORD Start;
    WORD Select;
    WORD A;
    WORD B;
    WORD X;
    WORD Y;
    WORD L;
    WORD R;
};

/*****************************************************************************/

extern struct sGUI GUI;
extern struct sLanguages Languages[];
extern struct SJoypad Joypad[4];

/*****************************************************************************/

#endif // !defined(SNES9X_H_INCLUDED)
